REM **************************************************************************
REM **************************************************************************
REM **************************************************************************
REM **************************************************************************
REM **********                                                      **********
REM **********                                                      **********
REM **********           COURS DE PROGRAMMATION EN QBASIC           **********
REM **********               par PHILIPPE-HENRY MARCY               **********
REM **********           http://membres.lycos.fr/firesnk/           **********
REM **********                                                      **********
REM **********                                                      **********
REM **************************************************************************
REM **************************************************************************
REM **********                                                      **********
REM **********                                                      **********
REM **********       EXEMPLE D'UTILISATION DU MODE GRAPHIQUE :      **********
REM **********                       ANIMATION                      **********
REM **********                                                      **********
REM **********                                                      **********
REM **************************************************************************
REM **************************************************************************
REM **************************************************************************
REM **************************************************************************





SCREEN 12
DIM Fond(175)     'Voir instruction GET
                  'Dimensions des images  copier : 37x17 / 17x37 / 35x35
                  'Taille = (  35 / 8  ) * 35
                  '       = (4.375 -> 5) * 35
                  '       = 175

GOSUB DessDecor
GOTO Animation


Temporise:
REM ***** Temporisation de l'animation *****
REM  ***    Rgler les paramtres des   ***
REM  ***   boucles FOR pour augmenter   ***
REM *****    ou diminuer la vitesse    *****
FOR Temp1 = 1 TO 10
    FOR Temp2 = 1 TO 2000: NEXT
NEXT
RETURN


DessDecor:
REM ** Routes **
COLOR 8     'Gris fonc
LINE (0, 180)-(540, 240), , BF
LINE (180, 0)-(240, 479), , BF
LINE (480, 0)-(540, 180), , BF
LINE (360, 240)-(420, 360), , BF
LINE (420, 300)-(639, 360), , BF
CIRCLE (465, 165), 15, , 4.7124, 0
PAINT (479, 179)
CIRCLE (480, 180), 60, 0, 4.7124, 0
PAINT (540, 240), 0, 0
CIRCLE (435, 285), 15, , 3.1416, 4.7124
PAINT (421, 299)
CIRCLE (420, 300), 60, 0, 3.1416, 4.7124
PAINT (360, 360), 0, 0

REM ** Lignes de dlimitation des voies **
COLOR 15     'Blanc
FOR I = 15 TO 145 STEP 26
    LINE (I, 210)-(I + 5, 210)
    LINE (210, I)-(210, I + 5)
NEXT
FOR I = 270 TO 452 STEP 26
    LINE (I, 210)-(I + 5, 210)
    LINE (210, I)-(210, I + 5)
NEXT
LINE (478, 210)-(481, 210)
LINE (482, 209)-(483, 209)
LINE (499, 199)-(501, 197)
LINE (501, 196)-(502, 195)
FOR I = 18 TO 174 STEP 26: LINE (510, I)-(510, I + 5): NEXT
LINE (390, 270)-(390, 275)
LINE (390, 296)-(390, 301)
LINE (400, 318)-(403, 321)
FOR I = 420 TO 628 STEP 26: LINE (I, 330)-(I + 5, 330): NEXT

REM ** Passages pour pitons **
FOR I = 185 TO 235 STEP 8
    LINE (160, I)-(174, I + 2), , BF
    LINE (246, I)-(260, I + 2), , BF
    LINE (I, 160)-(I + 2, 174), , BF
    LINE (I, 246)-(I + 2, 260), , BF
    LINE (I + 180, 246)-(I + 182, 260), , BF
NEXT

RETURN


DessVoitD:
REM ***** Dessin de la voiture se dirigeant vers la droite *****
REM ** Forme **
COLOR 4     'Rouge
LINE (X + 3, Y)-(X + 31, Y + 16), , BF
LINE (X + 1, Y + 1)-(X + 2, Y + 15), , BF
LINE (X, Y + 2)-(X, Y + 14)
LINE (X + 32, Y + 1)-(X + 34, Y + 15), , BF
LINE (X + 35, Y + 2)-(X + 36, Y + 14), , BF

REM ** Contours de la carrosserie **
COLOR 0     'Noir
LINE (X + 7, Y + 2)-(X + 30, Y + 2)
LINE (X + 7, Y + 14)-(X + 30, Y + 14)
LINE (X + 7, Y + 2)-(X + 7, Y + 14)
LINE (X + 7, Y + 2)-(X + 3, Y + 4)
LINE (X + 7, Y + 14)-(X + 3, Y + 12)
LINE (X + 3, Y + 4)-(X + 3, Y + 12)
LINE (X + 24, Y + 4)-(X + 24, Y + 12)
LINE (X + 25, Y + 3)-(X + 27, Y + 3)
LINE (X + 25, Y + 13)-(X + 27, Y + 13)
LINE (X + 32, Y + 4)-(X + 32, Y + 12)
PSET (X + 31, Y + 3)
PSET (X + 31, Y + 13)

REM ** Vitres **
PAINT (X + 26, Y + 8), 9, 0
PAINT (X + 4, Y + 8), 9, 0

REM ** Phares
COLOR 14     'Jaune
LINE (X + 36, Y + 4)-(X + 36, Y + 5), , BF
LINE (X + 36, Y + 11)-(X + 36, Y + 12), , BF

RETURN


DessVoitB:
REM ***** Dessin de la voiture se dirigeant vers le bas *****
REM ** Forme **
COLOR 4     'Rouge
LINE (X, Y + 3)-(X + 16, Y + 31), , BF
LINE (X + 1, Y + 1)-(X + 15, Y + 2), , BF
LINE (X + 2, Y)-(X + 14, Y)
LINE (X + 1, Y + 32)-(X + 15, Y + 34), , BF
LINE (X + 2, Y + 35)-(X + 14, Y + 36), , BF

REM ** Contours de la carrosserie **
COLOR 0     'Noir
LINE (X + 2, Y + 7)-(X + 2, Y + 30)
LINE (X + 14, Y + 7)-(X + 14, Y + 30)
LINE (X + 2, Y + 7)-(X + 14, Y + 7)
LINE (X + 2, Y + 6)-(X + 3, Y + 4)
LINE (X + 14, Y + 7)-(X + 12, Y + 3)
LINE (X + 4, Y + 3)-(X + 12, Y + 3)
LINE (X + 4, Y + 24)-(X + 12, Y + 24)
LINE (X + 3, Y + 25)-(X + 3, Y + 27)
LINE (X + 13, Y + 25)-(X + 13, Y + 27)
LINE (X + 4, Y + 32)-(X + 12, Y + 32)
PSET (X + 3, Y + 31)
PSET (X + 13, Y + 31)

REM ** Vitres **
PAINT (X + 8, Y + 26), 9, 0
PAINT (X + 8, Y + 4), 9, 0

REM ** Phares
COLOR 14     'Jaune
LINE (X + 4, Y + 36)-(X + 5, Y + 36), , BF
LINE (X + 11, Y + 36)-(X + 12, Y + 36), , BF

RETURN


DessVoitBD:
REM ***** Dessin de la voiture se dirigeant vers le bas et la droite *****
REM ** Forme **
COLOR 4     'Rouge
LINE (X + 2, Y + 13)-(X + 13, Y + 2)
LINE (X + 13, Y + 2)-(X + 32, Y + 21)
LINE (X + 32, Y + 21)-(X + 21, Y + 32)
LINE (X + 21, Y + 32)-(X + 2, Y + 13)
LINE (X + 2, Y + 12)-(X + 12, Y + 2)
LINE (X + 2, Y + 11)-(X + 11, Y + 2)
LINE (X + 2, Y + 10)-(X + 10, Y + 2)
LINE (X + 2, Y + 9)-(X + 9, Y + 2)
LINE (X + 32, Y + 22)-(X + 22, Y + 32)
LINE (X + 32, Y + 23)-(X + 23, Y + 32)
LINE (X + 33, Y + 23)-(X + 23, Y + 33)
LINE (X + 33, Y + 24)-(X + 24, Y + 33)
LINE (X + 34, Y + 24)-(X + 24, Y + 34)
LINE (X + 34, Y + 25)-(X + 25, Y + 34)
LINE (X + 34, Y + 26)-(X + 26, Y + 34)
LINE (X + 34, Y + 27)-(X + 27, Y + 34)
PAINT (X + 18, Y + 18)


REM ** Contours de la carrosserie **
COLOR 0     'Noir
LINE (X + 5, Y + 11)-(X + 11, Y + 5)
LINE (X + 8, Y + 14)-(X + 14, Y + 8)
LINE (X + 5, Y + 12)-(X + 6, Y + 14)
LINE (X + 12, Y + 5)-(X + 14, Y + 6)
LINE (X + 7, Y + 15)-(X + 22, Y + 30)
LINE (X + 15, Y + 7)-(X + 30, Y + 22)
PSET (X + 23, Y + 30)
PSET (X + 30, Y + 23)
LINE (X + 24, Y + 30)-(X + 30, Y + 24)
LINE (X + 19, Y + 26)-(X + 20, Y + 27)
LINE (X + 26, Y + 19)-(X + 27, Y + 20)
LINE (X + 19, Y + 25)-(X + 25, Y + 19)

REM ** Vitres **
PAINT (X + 10, Y + 10), 9, 0
PAINT (X + 26, Y + 26), 9, 0

REM ** Phares **
COLOR 14     'Jaune
LINE (X + 28, Y + 33)-(X + 29, Y + 32)
LINE (X + 33, Y + 28)-(X + 32, Y + 29)

RETURN


AffVoitD:
REM ***** Affiche la voiture qui avance vers la droite *****
GET (X, Y)-(X + 36, Y + 16), Fond
GOSUB DessVoitD
GOSUB Temporise
PUT (X, Y), Fond, PSET
RETURN


AffVoitB:
REM ***** Affiche la voiture qui avance vers le bas *****
GET (X, Y)-(X + 16, Y + 36), Fond
GOSUB DessVoitB
GOSUB Temporise
PUT (X, Y), Fond, PSET
RETURN


AffVoitBD:
REM ***** Affiche la voiture qui tourne *****
GET (X, Y)-(X + 34, Y + 34), Fond
GOSUB DessVoitBD
GOSUB Temporise
PUT (X, Y), Fond, PSET
RETURN


Animation:
REM ***** Animation de la voiture *****
REM ** Dlai avant le dbut de l'animation **
FOR I = 1 TO 15: GOSUB Temporise: NEXT
                                            
REM ** Premire ligne droite **
Y = 217
FOR X = 0 TO 176 STEP 4: GOSUB AffVoitD: NEXT

REM ** Premier tournant **
X = 182
Y = 219
GOSUB AffVoitBD
X = 187
Y = 221
GOSUB AffVoitB

REM ** Seconde ligne droite **
FOR Y = 221 TO 441 STEP 4: GOSUB AffVoitB: NEXT

REM ** Dlai avant la reprise de l'animation **
FOR I = 1 TO 10: GOSUB Temporise: NEXT

REM ** Troisime ligne droite **
FOR Y = 2 TO 206 STEP 4: GOSUB AffVoitB: NEXT

REM ** Second tournant **
Y = 212
X = 189
GOSUB AffVoitBD
Y = 217
X = 191
GOSUB AffVoitD

REM ** Quatrime ligne droite **
FOR X = 191 TO 355 STEP 4: GOSUB AffVoitD: NEXT

REM ** Troisime tournant **
X = 361
Y = 219
GOSUB AffVoitBD
X = 367
Y = 221
GOSUB AffVoitB

REM ** Cinquime ligne droite **
FOR Y = 221 TO 285 STEP 4: GOSUB AffVoitB: NEXT

REM ** Dernier tournant **
Y = 285
FOR I = 1 TO 3
    Y = Y + 4
    X = X + 1
    GOSUB AffVoitB
NEXT
Y = 301
X = 372
GOSUB AffVoitB
Y = 307
X = 374
GOSUB AffVoitBD
FOR I = 1 TO 6
    X = X + 3
    Y = Y + 3
    GOSUB AffVoitBD
NEXT
X = 394
Y = 331
GOSUB AffVoitD
X = 398
Y = 333
GOSUB AffVoitD
FOR I = 1 TO 4
    X = X + 4
    Y = Y + 1
    GOSUB AffVoitD
NEXT

REM ** Dernire ligne droite **
FOR X = 414 TO 602 STEP 4: GOSUB AffVoitD: NEXT

